unit frmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses SHFolder, shlObj;

function GetFolderPath(Wnd: HWnd; CSIDLFolder: Integer): string;
begin
  SetLength(Result, MAX_PATH);
  SHGetFolderPath(Wnd, CSIDLFolder, 0, 0, PChar(Result));
  SetLength(Result, StrLen(PChar(Result)));
  if (Result <> '') then
    Result  := IncludeTrailingBackslash(Result);
end;

function GetShellFolder(CSIDLFolder : integer) : string;

begin
  SetLength(Result, MAX_PATH);
  SHGetSpecialFolderPath(0, PChar(Result), CSIDLFolder, false);
  SetLength(Result, StrLen(PChar(Result)));
  if (Result <> '') then
    Result  := IncludeTrailingBackslash(Result);
end;

procedure TForm1.FormCreate(Sender: TObject);

Var
  FN,Dir : String;

begin
  Dir:=GetFolderPath(0,CSIDL_LOCAL_APPDATA);
  Label1.Caption:=Dir;
  Label2.Caption:=GetShellFolder(CSIDL_LOCAL_APPDATA);
  Dir:=Dir+ChangeFileExt(ExtractFileName(Application.ExeName),'');
  Label3.Caption:=Dir;
  If not ForceDirectories(Dir) then
    Raise Exception.CreateFmt('Failed to create settings directory %s',[Dir]);
  FN:=Dir+'settings.ini';
end;

end.
